perf test: Add sched latency and script shell tests

Add shell tests covering the `perf sched latency` and `perf sched
script` commands. The test creates 2 noploop processes on the same
forced CPU, it then checks that the process appears in the `perf
sched` output.

Reviewed-by: James Clark <james.clark@linaro.org>
Signed-off-by: Ian Rogers <irogers@google.com>
Link: https://lore.kernel.org/r/20250628012302.1242532-2-irogers@google.com
Signed-off-by: Namhyung Kim <namhyung@kernel.org>
This commit is contained in:
Ian Rogers 2025-06-27 18:23:02 -07:00 committed by Namhyung Kim
parent b6cea9b4f8
commit 0e22c5ca44
1 changed files with 93 additions and 0 deletions

93
tools/perf/tests/shell/sched.sh Executable file
View File

@ -0,0 +1,93 @@
#!/bin/bash
# perf sched tests
# SPDX-License-Identifier: GPL-2.0
set -e
if [ "$(id -u)" != 0 ]; then
echo "[Skip] No root permission"
exit 2
fi
err=0
perfdata=$(mktemp /tmp/__perf_test_sched.perf.data.XXXXX)
PID1=0
PID2=0
cleanup() {
rm -f "${perfdata}"
rm -f "${perfdata}".old
trap - EXIT TERM INT
}
trap_cleanup() {
echo "Unexpected signal in ${FUNCNAME[1]}"
cleanup
exit 1
}
trap trap_cleanup EXIT TERM INT
start_noploops() {
# Start two noploop workloads on CPU0 to trigger scheduling.
perf test -w noploop 10 &
PID1=$!
taskset -pc 0 $PID1
perf test -w noploop 10 &
PID2=$!
taskset -pc 0 $PID2
if ! grep -q 'Cpus_allowed_list:\s*0$' "/proc/$PID1/status"
then
echo "Sched [Error taskset did not work for the 1st noploop ($PID1)]"
grep Cpus_allowed /proc/$PID1/status
err=1
fi
if ! grep -q 'Cpus_allowed_list:\s*0$' "/proc/$PID2/status"
then
echo "Sched [Error taskset did not work for the 2nd noploop ($PID2)]"
grep Cpus_allowed /proc/$PID2/status
err=1
fi
}
cleanup_noploops() {
kill "$PID1" "$PID2"
}
test_sched_latency() {
echo "Sched latency"
start_noploops
perf sched record --no-inherit -o "${perfdata}" sleep 1
if ! perf sched latency -i "${perfdata}" | grep -q perf-noploop
then
echo "Sched latency [Failed missing output]"
err=1
fi
cleanup_noploops
}
test_sched_script() {
echo "Sched script"
start_noploops
perf sched record --no-inherit -o "${perfdata}" sleep 1
if ! perf sched script -i "${perfdata}" | grep -q perf-noploop
then
echo "Sched script [Failed missing output]"
err=1
fi
cleanup_noploops
}
test_sched_latency
test_sched_script
cleanup
exit $err